<?php
if (!defined('ABSPATH')) exit; // just in case

if(!current_user_can('manage_options')) {
	die('Access Denied');
}

global $wpdb;
global $wp_query;
$pre=$wpdb->prefix;
$runscan=false;
$nonce='';
if (array_key_exists('kpg_stop_spammers_control',$_POST)) $nonce=$_POST['kpg_stop_spammers_control'];
if (!empty($nonce) && wp_verify_nonce($nonce,'kpgstopspam_update')) { 
	if (array_key_exists('update_options',$_POST)) {
		$runscan=true;
	}
}



$nonce=wp_create_nonce('kpgstopspam_update');

?>

<h2>Threat Scan</h2>
<p>This is a very simple threat scan that looks for things out of place in the content directory as well as the database.</p>
<p>The process searches PHP files for the occurrence of the eval() function, which, although a valuable part of PHP is also the door that hackers use in order to infect systems. The eval() function is avoided by many programmers unless there is a real need. It is often used by hackers to hide their malicious code or to inject future threats into infected systems. If you find a theme or a plugin that uses the eval() function it is safer to delete it and ask the author to provide a new version that does not use this function.</p>
<p>The scan can take a few seconds and on larger or slower systems can time-out.</p>
<form method="post" action="">
  <input type="hidden" name="update_options" value="update" />
  <input type="hidden" name="kpg_stop_spammers_control" value="<?php echo $nonce;?>" />
  <p class="submit">
    <input class="button-primary" value="Run Scan" type="submit" />
  </p>
</form>
<?php 

if ($runscan) {
	?>
<p>When you scan your system you undoubtedly see the eval used in javascript because it is used in the javascript AJAX and JSON functionality. The appearance of eval in these cases does not mean that there is a possible threat. It just means that you should inspect the code to make sure that it is in a javascript section and not native PHP.</p>
<p>The process continues its scan by checking the database tables for javascript or html where it should not be found.</p>
<p>Normally, javascript can be found in the post body, but if the script tag is found in a title or a text field where it does not belong it is probably because the script is hiding something, such as a hidden admin user, so that the normal administration pages do not show bad records. The scan looks for this and displays the table and record number where it believes there is something hinky.</p>
<p>The scan continues looking in the database for certain html in places where it does not belong. Recent threats have been putting html into fields in the options table so that users will be sent to malicious sites. The presence of html in options values is suspect and should be checked.</p>
<p>The options table will have things placed there by plugins so it is difficult to tell if scripts, iframes, and other html tags are a threat. They will be reported, but they should be checked before deleting the entries.</p>
<p>This process is just a simple scan and does not try to fix any problems. It will show things that may not be threats, but should be checked. If anything shows up you, should try to repair the damage or hire someone to do it. I am not a security expert, but a programmer who discovered these types of things in a friend's blog. After many hours of checking I was able to fix the problem, but a professional could have done it faster and easier, although they would have charged for it.</p>
<p>You probably do not have a backup to your blog, so if this scan shows you are clean; your next step is to install one of the plugins that does regular backups of your system. Next make sure you have the latest WordPress version.</p>
<p>If you think you have problems, the first thing to do is change your user id and password. Next make a backup of the infected system. Any repairs to Wordpress might delete important data so you might lose posts, and the backup will help you recover missing posts.</p>
<p>The next step is to install the latest version of WordPress. The new versions usually have fixes for older threats.</p>
<p>You may want to export your WordPress posts, make a new clean installation of WordPress, and then import the old posts.</p>
<p>If this doesn't work it is time to get a pro involved.</p>
<h3>A clean scan does not mean you are safe. Please do Backups and keep your installation up to date!</h3>
<hr/>
<?php

	

	$disp=false;
	flush();
	// lets try the posts. Looking for script tags in data
	echo "<br/><br/>Testing Posts<br/>";
	$ptab=$pre.'posts';
	$sql= "select ID,post_author,post_title,post_name,guid,post_content,post_mime_type
from $ptab where 
INSTR(LCASE(post_author), '<script') +
INSTR(LCASE(post_title), '<script') +
INSTR(LCASE(post_name), '<script') +
INSTR(LCASE(guid), '<script') +
INSTR(LCASE(post_author), 'eval(') +
INSTR(LCASE(post_title), 'eval(') +
INSTR(LCASE(post_name), 'eval(') +
INSTR(LCASE(guid), 'eval(') +
INSTR(LCASE(post_content), 'eval(') +
INSTR(LCASE(post_content), 'document.write(unescape(') +
INSTR(LCASE(post_content), 'try{window.onload') +
INSTR(LCASE(post_content), 'setAttribute(\'src\'') +
INSTR(LCASE(post_mime_type), 'script') +
INSTR(LCASE(document.write(string.fromcharcode), 'script') >0


";
	//echo " <br/> $sql <br/>";
	flush();
	$myrows = $wpdb->get_results( $sql );
	if ($myrows) {
		foreach ($myrows as $myrow) {
			$disp=true;
			$reason='';
			if (strpos(strtolower($myrow->post_author),'<script')!==false) $reason.="post_author:&lt;script "; 
			if (strpos(strtolower($myrow->post_title),'<script')!==false) $reason.="post_title:&lt;script "; 
			if (strpos(strtolower($myrow->post_name),'<script')!==false) $reason.="post_name:&lt;script "; 
			if (strpos(strtolower($myrow->guid),'<script')!==false) $reason.="guid:&lt;script "; 

			if (strpos(strtolower($myrow->post_author),'eval(')!==false) $reason.="post_author:eval() "; 
			if (strpos(strtolower($myrow->post_title),'eval(')!==false) $reason.="post_title:eval() "; 
			if (strpos(strtolower($myrow->post_name),'eval(')!==false) $reason.="post_name:eval() "; 
			if (strpos(strtolower($myrow->guid),'eval(')!==false) $reason.="guid:eval() "; 
			if (strpos(strtolower($myrow->post_content),'eval(')!==false) $reason.="post_content:eval() "; 
			
			if (strpos(strtolower($myrow->post_content),'document.write(unescape(')!==false) $reason.="post_content:document.write(unescape( "; 
			if (strpos(strtolower($myrow->post_content),'try{window.onload')!==false) $reason.="post_content:try{window.onload "; 
			if (strpos(strtolower($myrow->post_content),"setAttribute('src'")!==false) $reason.="post_content:setAttribute('src' "; 
			if (strpos(strtolower($myrow->post_mime_type),'script')!==false) $reason.="post_mime_type:script "; 
			
			
			
			echo "found possible problems in post ($reason) ID: ". $myrow->ID.'<br/>';
		}
	} else {
		echo "<br/>nothing found in posts<br/>";
		$disp=false;
	}
	echo "<hr/>";
	//comments: comment_ID: author_url, comment_agent, comment_author, comment_email
	$ptab=$pre.'comments';
	echo "<br/><br/>Testing Comments<br/>";
	flush();
	$sql="select comment_ID,comment_author_url,comment_agent,comment_author,comment_author_email,comment_content
from $ptab where 
INSTR(LCASE(comment_author_url), '<script') +
INSTR(LCASE(comment_agent), '<script') +
INSTR(LCASE(comment_author), '<script') +
INSTR(LCASE(comment_author_email), '<script') +
INSTR(LCASE(comment_author_url), 'eval(') +
INSTR(LCASE(comment_agent), 'eval(') +
INSTR(LCASE(comment_author), 'eval(') +
INSTR(LCASE(comment_author_email), 'eval(') +
INSTR(LCASE(comment_content), '<script') +
INSTR(LCASE(comment_content), 'eval(') +
INSTR(LCASE(comment_content), 'document.write(unescape(') +
INSTR(LCASE(comment_content), 'try{window.onload') +
INSTR(LCASE(comment_content), 'setAttribute(\'src\'') +
INSTR(LCASE(comment_author_url), 'javascript:') >0
";
	$myrows = $wpdb->get_results( $sql );
	if ($myrows) {
		foreach ($myrows as $myrow) {
			$disp=true;
			$reason='';
			if (strpos(strtolower($myrow->comment_author_url),'<script')!==false) $reason.="comment_author_url:&lt;script "; 
			if (strpos(strtolower($myrow->comment_agent),'<script')!==false) $reason.="comment_agent:&lt;script "; 
			if (strpos(strtolower($myrow->comment_author),'<script')!==false) $reason.="comment_author:&lt;script "; 
			if (strpos(strtolower($myrow->comment_author_email),'<script')!==false) $reason.="comment_author_email:&lt;script ";
			if (strpos(strtolower($myrow->comment_content),'<script')!==false) $reason.="comment_content:&lt;script ";
			
			if (strpos(strtolower($myrow->comment_author_url),'eval(')!==false) $reason.="comment_author_url:eval() "; 
			if (strpos(strtolower($myrow->comment_agent),'eval(')!==false) $reason.="comment_agent:eval() "; 
			if (strpos(strtolower($myrow->comment_author),'eval(')!==false) $reason.="comment_author:eval() "; 
			if (strpos(strtolower($myrow->comment_author_email),'eval(')!==false) $reason.="comment_author_email:eval() "; 
			if (strpos(strtolower($myrow->comment_content),'eval(')!==false) $reason.="comment_content:eval() "; 
			
			if (strpos(strtolower($myrow->comment_content),'document.write(unescape(')!==false) $reason.="comment_content:document.write(unescape( ";
			if (strpos(strtolower($myrow->comment_content),'try{window.onload')!==false) $reason.="comment_content:try{window.onload ";
			if (strpos(strtolower($myrow->comment_content),"setAttribute('src'")!==false) $reason.="comment_content:setAttribute('src' ";
			if (strpos(strtolower($myrow->comment_content),'javascript:')!==false) $reason.="comment_content:javascript: ";
			
			
			
			echo "found possible problems in comment ($reason) ID". $myrow->comment_ID.'<br/>';
		}
	} else {
		echo "<br/>nothing found in Comments<br/>";
	}
	flush();
	echo "<hr/>";
	// links: links_id: link_url, link_image, link_description, link_notes, link_rss,link_rss
	$ptab=$pre.'links';
	echo "<br/><br/>Testing Links<br/>";
	flush();
	$sql="select link_ID,link_url,link_image,link_description,link_notes
from $ptab where 
INSTR(LCASE(link_url), '<script') +
INSTR(LCASE(link_image), '<script') +
INSTR(LCASE(link_description), '<script') +
INSTR(LCASE(link_notes), '<script') +
INSTR(LCASE(link_rss), '<script') +
INSTR(LCASE(link_url), 'eval(') +
INSTR(LCASE(link_image), 'eval(') +
INSTR(LCASE(link_description), 'eval(') +
INSTR(LCASE(link_notes), 'eval(') +
INSTR(LCASE(link_rss), 'eval(') +
INSTR(LCASE(link_url), 'javascript:') >0
";

	$myrows = $wpdb->get_results( $sql );
	if ($myrows) {
		foreach ($myrows as $myrow) {
			$reason=''; 
			if (strpos(strtolower($myrow->link_url),'<script')!==false) $reason.="link_url:&lt;script "; 
			if (strpos(strtolower($myrow->link_image),'<script')!==false) $reason.="link_image:&lt;script "; 
			if (strpos(strtolower($myrow->link_description),'<script')!==false) $reason.="link_description:&lt;script "; 
			if (strpos(strtolower($myrow->link_notes),'<script')!==false) $reason.="link_notes:&lt;script "; 
			if (strpos(strtolower($myrow->link_rss),'<script')!==false) $reason.="link_rss:&lt;script "; 
			
			if (strpos(strtolower($myrow->link_url),'eval(')!==false) $reason.="link_url:eval() "; 
			if (strpos(strtolower($myrow->link_image),'eval(')!==false) $reason.="link_image:eval() "; 
			if (strpos(strtolower($myrow->link_description),'eval(')!==false) $reason.="link_description:eval() "; 
			if (strpos(strtolower($myrow->link_notes),'eval(')!==false) $reason.="link_notes:eval() "; 
			if (strpos(strtolower($myrow->link_rss),'eval(')!==false) $reason.="link_rss:eval() "; 

			if (strpos(strtolower($myrow->link_url),'javascript:')!==false) $reason.="link_url:javascript: "; 
			
			echo "found possible problems in links ($reason) ID:". $myrow->link_ID.'<br/>';
		}
	} else {
		echo "<br/>nothing found in Links<br/>";
	}
	echo "<hr/>";

	//users: ID: user_login,user_nicename, user_email, user_url, display_name
	$ptab=$pre.'users';
	echo "<br/><br/>Testing Users<br/>";
	flush();
	$sql="select ID,user_login,user_nicename,user_email,user_url,display_name 
from $ptab where 
INSTR(LCASE(user_login), '<script') +
INSTR(LCASE(user_nicename), '<script') +
INSTR(LCASE(user_email), '<script') +
INSTR(LCASE(user_url), '<script') +
INSTR(LCASE(display_name), '<script') +
INSTR(user_login, 'eval(') +
INSTR(user_nicename, 'eval(') +
INSTR(user_email, 'eval(') +
INSTR(user_url, 'eval(') +
INSTR(display_name, 'eval(') +
INSTR(LCASE(user_url), 'javascript:') +
INSTR(LCASE(user_email), 'javascript:')>0
";
	$myrows = $wpdb->get_results( $sql );
	if ($myrows) {
		foreach ($myrows as $myrow) {
			$disp=true;
			$reason='';
			if (strpos(strtolower($myrow->user_login),'<script')!==false) $reason.="user_login:&lt;script "; 
			if (strpos(strtolower($myrow->user_nicename),'<script')!==false) $reason.="user_nicename:&lt;script "; 
			if (strpos(strtolower($myrow->user_email),'<script')!==false) $reason.="user_email:&lt;script "; 
			if (strpos(strtolower($myrow->user_url),'<script')!==false) $reason.="user_url:&lt;script "; 
			if (strpos(strtolower($myrow->display_name),'<script')!==false) $reason.="display_name:&lt;script ";
			
			if (strpos(strtolower($myrow->user_login),'eval(')!==false) $reason.="user_login:eval() "; 
			if (strpos(strtolower($myrow->user_nicename),'eval(')!==false) $reason.="user_nicename:eval() "; 
			if (strpos(strtolower($myrow->user_email),'eval(')!==false) $reason.="user_email:eval() "; 
			if (strpos(strtolower($myrow->user_url),'eval(')!==false) $reason.="user_url:eval() "; 
			if (strpos(strtolower($myrow->display_name),'eval(')!==false) $reason.="display_name:eval() "; 
			
			if (strpos(strtolower($myrow->user_email),'javascript:')!==false) $reason.="user_email:javascript: "; 
			if (strpos(strtolower($myrow->user_url),'javascript:')!==false) $reason.="user_url:javascript: "; 
			echo "found possible problems in Users ($reason) ID:". $myrow->ID.'<br/>';
		}
	} else {
		echo "<br/>nothing found in Users<br/>";
	}
	echo "<hr/>";

	//options: option_id option_value, option_name
	// I may have to update this as new websites show up
	$ptab=$pre.'options';
	echo "<br/><br/>Testing Options table for html<br/>";
	flush();
	$badguys=array(
		'eval('=>'eval function found',
		'networkads'=>'unexpected network ads reference',
		'document.write(unescape('=>'javascript document write unescape',
		'try{window.onload'=>'javascript onload event',
		'escape(document['=>'javascript checking document array',
		'escape(navigator['=>'javascript checking navigator',
		'document.write(string.fromcharcode'=>'obsfucated javascript write',
		'(base64'.'_decode'.'(gzun'.'compress'=>'base64 decode with gzip uncompress',
	);

	$sql="select option_id,option_value,option_name
from $ptab where
";
	foreach ($badguys as $baddie=>$reas) {
		$sql.="INSTR(LCASE(option_value), '$baddie') +";
	}
	$sql=trim($sql,'+');

	$myrows = $wpdb->get_results( $sql );
	if ($myrows) {
		foreach ($myrows as $myrow) {
			// get the option and then red the string
			$id=$myrow->option_id;
			$name=$myrow->option_name;
			$line=$myrow->option_value;
			$line=htmlentities($line);
			$line=strtolower($line);
			$reason='';
			if (strpos($name,'_transient_feed_')===false) {
				$disp=true;
				foreach ($badguys as $baddie=>$reas) {
					if (!(strpos($line,$baddie)===false)) {
						// bad boy
						$line=kpg_ss_make_red($baddie,$line);
						$reason.=$reas.' ';
					} 
				}
			}				
			echo "<b>found possible problems in Option $name ($reason)</b> option_id:". $myrow->option_id.", value: $line<br/><br/>";
		}
	} else {
		echo "<br/>nothing found in Options<br/>";
	}
	echo "<hr/>";
	echo "<h3>Scanning Themes and Plugins for eval</h3>";
	flush();
	if (kpg_ss_scan_for_eval()) $disp=true;;

	if ($disp) {
		?>
<h3>Possible problems found!</h3>
<p>These are warnings, only. Some content and plugins might not be malicious, but still contain one or more of these indicators. Please investigate all indications of problems. The plugin may err on the side of caution.</p>
<p>Although there are legitimate reasons for using the eval function, and javascript uses it frequently,
  finding eval in PHP code is in the very least bad practice, and the worst is used to hide malicious code. If eval() comes up in a scan, try to get rid of it. </p>
<p>Your code could contain 'eval', or 'document.write(unescape(' or 'try{window.onload' or setAttribute('src'. These are markers for problems such as sql injection or cross-browser javascript. &lt;script&gt; tags should might occur in your posts, if you added them, but should not be found anywhere else, except options. Options often have scripts for displaying facebook, twitter, etc. Be careful, though, if one appears in an option. Most of the time it is OK, but make sure.</p>
<?php
		
	} else {
		?>
<h3>No problems found!</h3>
<p>It appears that there are no eval or suspicious javascript functions in the code in your wp-content directory. That does not mean that you are safe, only that a threat may be well hidden.</p>
<?php	
	}
	flush();

} // end if runscan
function kpg_ss_scan_for_eval() {
	// scan content completely
	// WP_CONTENT_DIR is supposed to have the content dir
	$phparray=array();
	$phparray=kpg_ss_scan_for_eval_recurse(WP_CONTENT_DIR.'/..',$phparray);
	// phparray should have a list of all of the PHP files
	$disp=false;
	echo "Files: <ol>";
	for ($j=0;$j<count($phparray);$j++) {
		// ignore my work on this subject
		if (strpos($phparray[$j],'threat_scan')===false&&strpos($phparray[$j],'threat-scan')===false) {
			$ansa=kpg_ss_look_in_file($phparray[$j]);
			if (count($ansa)>0) {
				$disp=true;
				//echo "Think we got something<br>";
				echo "<li>".$phparray[$j]." <br/> ";
				for ($k=0;$k<count($ansa);$k++) {
					echo $ansa[$k]." <br/>"; 
				}
				echo "</li>";
			}
		}
	}  
	echo "</ol>";
	return $disp;

} // end of function

// recursive walk of directory structure.
function kpg_ss_scan_for_eval_recurse($dir,$phparray) {
	if (!is_dir($dir))  return $phparray;

	if ($dh = opendir($dir)) {
		while (($file = readdir($dh)) !== false) {
			if (is_dir($dir .'/'. $file)) {
				if ($file!='.' && $file!='..' ) {
					$phparray=kpg_ss_scan_for_eval_recurse($dir .'/'. $file,$phparray);
				}
			} else if ( strpos($file,'.php')>0 ) {
				$phparray[count($phparray)]=$dir .'/'. $file;
			} else {
				//echo "can't find .php in $file <br/>";
			}
		}
		closedir($dh);
	}
	return $phparray;

}	
function kpg_ss_look_in_file($file) {
	if (!file_exists($file)) return false;
	// don't look in this plugin because it finds too much stuff
	// only look for .php files - no more javascript
	if (strpos($file,'.php')===false) return false;
	$handle=fopen($file,'r');
	$ansa=array();
	$n=0;
	$idx=0;
	$badguys=array(
		'eval(',
		'document.write(unescape(',
		'try{window.onload',
		'escape(document[',
		'escape(navigator[',
		"setAttribute('src'",
		'document.write(string.fromcharcode',
		'(base64'.'_decode'.'(gzun'.'compress',
		'if(!isset($GLOBALS['."\\'\\a\\e\\0"
	);
	while (!feof($handle)) {
		$line=fgets($handle);
		$line=htmlentities($line);
		$n++;
		foreach($badguys as $baddie) {		
			if (!(strpos($line,$baddie)===false)) {
				// bad boy
				if (kpg_ss_ok_list($file,$n)) {
					$line=kpg_ss_make_red($baddie,$line);
					$ansa[$idx]=$n.': '.$line;
					$idx++;
				}
			} 
		}
		// search line for $xxxxx() type things
		$m=0;
		$f=false;
		$vchars='!@#$%^&*),.;:\"[]{}?/+=_- \t\\|~`<>'."'"; // not part of variable names
		while ($m<strlen($line)-2) {
			$m=strpos($line,'$',$m);
			if ($m===false) break;
			if (substr($line,$m,7)!='$class(') { // used often and correctly
				$mi=$m;
				$mi++;
				for ($mm=$mi;($mm<$mi+8&&$mm<strlen($line));$mm++) {
					$c=substr($line,$mm,1);
					if ($c=='(' && $mm>$mi) { // need at least a character so as not to kill jquery
						$f=true;
						break;
					}
					if (strpos($vchars,$c)!==false) {
						break;
					}
					
				}
			}
			if ($f) break;
			$m++;
		}
		if ($f) {
			if (kpg_ss_ok_list($file,$n)) {
				$ll=substr($line,$m,7);
				$line=kpg_ss_make_red($ll,$line);
				$ansa[$idx]=$n.': '.$line;
				$idx++;
			}
		}
		
	}
	fclose($handle);
	return $ansa;
}
function kpg_ss_make_red($needle,$haystack) {
	// turns error red
	$j=strpos($haystack,$needle);
	$s=substr_replace($haystack, '</span>', $j+strlen($needle), 0);
	$s=substr_replace($s, '<span style="color:red;">', $j, 0);
	return $s;
}	
function kpg_ss_ok_list($file,$line) {
	$dontreport=array( // list of occurences in WP which are expected and the line number (floor base 100
	'/stop-spammer-registrations-new.php'=>340,
	'/stop-spammer-registrations.php'=>340,
	'modules/chkexploits.php'=>0,
	'wp-admin/includes/class-pclzip.php'=>4000,
	'wp-includes/class-json.php'=>0,
	'JSON/JSON.php '=>0,
	'wp-includes/compat.php'=>40,
	'wp-includes/functions.php'=>180,
	'wp-includes/pluggable.php'=>1350,
	'wp-includes/SimplePie/Sanitize.php'=>300,
	'wp-admin/press-this.php'=>200,
	'p-admin/press-this.php'=>400,
	// 4.1 wordpress moved some stuff and added session.php execute.
	'p-includes/pluggable.php'=>1700,
	'wp-includes/session.php'=>40

	);
	
	foreach($dontreport as $f=>$ln) {
		if (strpos($file,$f)!==false) {
			//echo "checking $file, $f for $line and '$ln'<br>";
			if($line>=$ln && $line<=($ln+100)) return false;
		}
	}
	if (strpos($file,'stop-spammers') !== false) return false;
	return true;
}	





?>
